local WarehouseCapacity = 50000
local TeamsterCarry = 1000




--下面的不需要编辑.

OnMsg.ClassesPreprocess = function()
	const.TeamsterWarehouseCapacity = WarehouseCapacity
	const.TeamsterBaseCapacity = TeamsterCarry
	DefineClass.DarthStorageComponent = {properties = {{category = T({"Resource"}),id = "Resource",name = T({"Resource"}),default = "",editor = "dropdownlist",items = ResourcesCombo,needs_value = true},{category = T({"Capacity"}),id = "Capacity",name = T({"Capacity"}),default = 10000,editor = "number"}}}
	DefineClass.DarthStorage = {__parents = {"DarthStorageComponent","CommonBuildingComponent","ComponentLifeTimeController"},id = "darthstorage",MenuName = T({"Add Storage"}),singleton = false,automatic_label = true,built = false,power_shortage = false,ui_state = "Off",fixed = false}
	DefineClass.DarthImportExportComponent = {properties = {{category = T({"Resource"}),id = "Resource",name = T({"Resource"}),default = "",editor = "dropdownlist",items = ResourcesCombo,needs_value = true}}}
	DefineClass.DarthExport = {__parents = {"DarthImportExportComponent","CommonBuildingComponent","ComponentLifeTimeController"},id = "darthexport",MenuName = T({"Allow Export"}),singleton = false,automatic_label = true,built = false,power_shortage = false,ui_state = "Off",fixed = false}
	DefineClass.DarthImport = {__parents = {"DarthImportExportComponent","CommonBuildingComponent","ComponentLifeTimeController"},id = "darthimport",MenuName = T({"Allow Import"}),singleton = false,automatic_label = true,built = false,power_shortage = false,ui_state = "Off",fixed = false}
	function DarthStorage:OnAdd()
		local resource = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		if not storage then
			storage = Storage:new()
			self.parent:AddComponent(storage)
		end
		local res = storage.resources[resource]
		if res then
			res.capacity = Max(res.capacity, self["Capacity"])
			return
		end
		storage.resources[resource] = {capacity = self["Capacity"],intent = "output",input = false,output = false,ingoing = 0,outgoing = 0,amount = 0}
	end
	function DarthStorage:TurnOn()
		local res = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		local resdata = storage.resources[res]
		resdata.input = true
		resdata.output = true
		self.built = true
	end
	function DarthStorage:TurnOff()
		local res = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		local resdata = storage.resources[res]
		resdata.input = false
		resdata.output = true
	end
	function DarthExport:OnAdd()
		local resource = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		if not storage then
			storage = Storage:new()
			self.parent:AddComponent(storage)
		end
		local res = storage.resources[resource]
		if res then
			res.AllowExport = false
			return
		end
		storage.resources[resource] = {capacity = self["Capacity"],intent = "output",input = false,output = false,ingoing = 0,outgoing = 0,amount = 0,AllowExport = false}
	end
	function DarthExport:TurnOn()
		local res = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		local resdata = storage.resources[res]
		resdata.AllowExport = true
		self.built = true
	end
	function DarthExport:TurnOff()
		local res = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		local resdata = storage.resources[res]
		resdata.AllowExport = false
	end
	function DarthImport:OnAdd()
		local resource = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		if not storage then
			storage = Storage:new()
			self.parent:AddComponent(storage)
		end
		local res = storage.resources[resource]
		if res then
			res.AllowImport = false
			return
		end
		storage.resources[resource] = {capacity = self["Capacity"],intent = "output",input = false,output = false,ingoing = 0,outgoing = 0,amount = 0,AllowImport = false}
	end
	function DarthImport:TurnOn()
		local res = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		local resdata = storage.resources[res]
		resdata.AllowImport = true
		self.built = true
	end
	function DarthImport:TurnOff()
		local res = self["Resource"]
		local storage = self.parent:FindFirstComponent("Storage")
		local resdata = storage.resources[res]
		resdata.AllowImport = false
	end
	function GetBestDockToImport(city, resource_name,ignore)
		local docks = city.labels.Docks:GetObjects()
		local min_quantity, dock_bld, waiting_ships
		local start_idx = Random(1, #docks, "GetBestDock")
		local i = start_idx
		while true do
			local d = docks[i]
			local res = d.storage and d.storage.resources[resource_name]
			if res.AllowImport or ignore then
				if res and d.dock:GetPathSplines(2) then
					local amount = res.amount - res.outgoing
					local ships = d.dock:GetWaitingShipsCount(2)
					local demand = d.dock:GetResourceDemand(resource_name)
					local quantity = amount - demand
					quantity = quantity < 0 and quantity / (ships + 1) or quantity * (ships + 1)
					if not min_quantity or min_quantity > quantity then
						dock_bld = d
						min_quantity = quantity
						waiting_ships = ships
					end
				end
			end
			i = i == #docks and 1 or i + 1
			if i == start_idx then
				break
			end
		end
		if not dock_bld and not ignore then
			dock_bld, waiting_ships = GetBestDockToImport(city, resource_name,true)
		end
		return dock_bld, waiting_ships
	end
	
	function Storage:IsResourceUsedInProduction(res)
		local parent = self.parent
		if parent.production then
			for i = 1, #parent.production do
				local component = parent.production[i]
				if self.resources[res].input then
					if component:IsKindOf("Production") and (component.InputResource1 == res or component.InputResource2 == res or component.InputResource3 == res) then
						return true
					end
				elseif component.OutputResource == res then
					return true
				end
			end
		end
		if res == "Food" and parent:FindFirstComponent("FoodDistributor") then
			return true
		end
		if parent.production_power then
			for i = 1, #parent.production_power do
				local component = parent.production_power[i]
				if component:IsKindOf("ProductionPower") and component.InputResource == res then
					return true
				end
			end
		end
		if parent:FindFirstComponent("DarthStorage") then
			local amt = self.resources[res].amount
			if amt > 0 then
				if self.resources[res].input and self.resources[res].output then
					local toggle = self.resources[res].ToggleCheck
					if not toggle then
						self.resources[res].ToggleCheck = true
						return true
					else
						self.resources[res].ToggleCheck = false
						return false
					end
				else
					self.resources[res].ToggleCheck = false
					return true
				end	
			end
		end
	end
	function TeamstersOfficeWorkCycle(unit, teamsters_office)
		local max_capacity = const.TeamsterBaseCapacity * teamsters_office:GetEffectiveness() / 100
		while true do
			do
				local success = false
				local load_bld, store_bld, res, amount = DarthFindBuildingToLoad(teamsters_office, max_capacity)
				if load_bld then
					do
						local original_city = load_bld.city
						local res_t = load_bld.storage:GetResourceInfo(res)
						unit:PushDestructor(function()
							res_t.outgoing = res_t.outgoing - amount
						end)
						res_t.outgoing = res_t.outgoing + amount
						success = unit:GotoBuilding(load_bld, unit.city.CurrentEra == 1 and "HandCartTeamster" or "Truck")
						unit:PopAndCallDestructor()
						if success and load_bld.storage and amount > 0 then
							unit:PushDestructor(function()
								DarthReturnResourcesBack(load_bld, res, amount)
							end)
							load_bld.storage:ChangeAmount(res, -amount)
							load_bld:UpdateResourcePiles()
							success = false
							while IsValid(store_bld) and store_bld.storage do
								do
									local res_real = DarthIsBuildingFoodDistributor(store_bld) and FoodResources[res] and "Food" or res
									local res_t = store_bld.storage:GetResourceInfo(res_real)
									unit:PushDestructor(function()
										res_t.ingoing = res_t.ingoing - amount
									end)
									res_t.ingoing = res_t.ingoing + amount
									success = unit:GotoBuilding(store_bld, unit.city.CurrentEra == 1 and "HandCartTeamster" or "Truck")
									unit:PopAndCallDestructor()
									if success and store_bld.storage then
										store_bld.storage:ChangeAmount(res_real, amount, 0)
										store_bld:UpdateResourcePiles()
										break
									else
										store_bld = false
										local from = unit.car and unit.car:GetCurrentTransportJunction()
										if from then
											local isDarthWarehouse = load_bld:FindFirstComponent("DarthStorage") and true or false
											store_bld = DarthFindBuildingToStore(original_city, from, res_real,isDarthWarehouse)
											if not store_bld and not load_bld.dock then
												if isDarthWarehouse then
													if res_t.input == false then
														store_bld = DarthFindClosestDock(bld.city, bld.garage, res_real)
													end
												else
													store_bld = DarthFindClosestDock(original_city, from, res_real)
												end
											end
										end
									end
								end
							end
							if success then
								unit:PopDestructor()
							else
								unit:PopAndCallDestructor()
							end
						elseif unit.holder ~= unit.workplace then
							unit:GotoBuilding(unit.workplace)
						else
							Sleep(5000)
						end
					end
				elseif unit.holder ~= unit.workplace then
					unit:GotoBuilding(unit.workplace)
				else
					Sleep(1000)
				end
				if not IsValid(teamsters_office) or not teamsters_office.workplace or not teamsters_office.workplace:NeedWorkerOnDuty(unit) then
					break
				end
				Sleep(1000)
			end
		end
	end
	
end
OnMsg.DataLoaded = function()
	local res = {"香蕉","铝土矿","煤","可可","咖啡","玉米","棉花","鱼","金","铁","鱼类","肉","牛奶","天然气","石油","菠萝","糖","烟草","铀","羊毛"}
	for i = 1, #res do
		table.insert(DataInstances.BuildingTemplate.TeamstersOffice,PlaceObj("Upgrade", {"Id","Store" .. res[i],"Name","储存 " .. res[i],"Rollover","使用仓库" .. res[i],'Toggle',true,"StartTurnedOn",false,"StartingEra",1}))
		table.insert(DataInstances.BuildingTemplate.TeamstersOffice,PlaceObj("DarthStorage", {"Resource",res[i],"Capacity",const.TeamsterWarehouseCapacity,"EnabledBy","Store" .. res[i]}))
	end
	res = {"服装","香蕉","铝土矿","罐头","汽车","奶酪","巧克力","雪茄","布","煤","可可","咖啡","玉米","棉花","电子","鱼","家具","金","铁","珠宝","日志","肉","牛奶","天然气","石油","药品","菠萝","木板","酒","钢","糖","烟草","铀","羊毛"}
	for i = 1, #res do
		table.insert(DataInstances.BuildingTemplate.ColonialDock,PlaceObj("Upgrade", {"Id","AllowImport" .. res[i],"Name","进口 " .. res[i],"Rollover","允许进口" .. res[i],'Toggle',true,"StartTurnedOn",false,"StartingEra",1}))
		table.insert(DataInstances.BuildingTemplate.ColonialDock,PlaceObj("DarthImport", {"Resource",res[i],"EnabledBy","AllowImport" .. res[i]}))
		table.insert(DataInstances.BuildingTemplate.ColonialDock,PlaceObj("Upgrade", {"Id","AllowExport" .. res[i],"Name","出口 " .. res[i],"Rollover","应许出口" .. res[i],'Toggle',true,"StartTurnedOn",true,"StartingEra",1}))
		table.insert(DataInstances.BuildingTemplate.ColonialDock,PlaceObj("DarthExport", {"Resource",res[i],"EnabledBy","AllowExport" .. res[i]}))
	end
	DebugPrint("Resource Manager mod by DarthPresidente loaded...\n    Version:  	1.0\n    SourceFile: " .. debug.getinfo(1).source:match("@(.*)$") .. "\n\n")
end

function DarthIsBuildingFoodDistributor(building)
	local food_distributor = false
	if building:HasMember("service") and building.service then
		for i = 1, #building.service do
			if building.service[i].class == "FoodDistributor" then
				food_distributor = true
			end
		end
	end
	return food_distributor
end

function DarthReturnResourcesBack(resource_source, resource_name, loaded_amount)
	if IsValid(resource_source) and loaded_amount > 0 and resource_source.storage then
		resource_source.storage:ChangeAmount(resource_name, loaded_amount)
		resource_source:UpdateResourcePiles()
	end
end
function DarthGetDistToBuilding(garage_or_road, bld)
	local path_length = g_RoadTransport:GetPathLength(garage_or_road, bld.garage)
	if path_length then
		path_length = path_length + bld:Random(200 * guim, "noise in the dock distances")
		return Max(path_length, 0)
	end
end

function DarthFindClosestDock(original_city, garage_or_road, resource)
	local docks = original_city.labels.Docks:GetObjects()
	local closest_dock, closest_distance, closest_empty_dock, closest_empty_dock_distance
	for i = 1, #docks do
		local dock = docks[i]
		if not (resource and dock.storage.resources[resource] and dock.storage.resources[resource].AllowExport == false) then
			local path_dist = DarthGetDistToBuilding(garage_or_road, dock)
			if path_dist then
				local path_weight = path_dist - dock.BudgetLevel * 30 * guim
				local amount = dock.storage:TotalAmount()
				if not closest_dock or closest_distance > path_weight then
					closest_dock = dock
					closest_distance = path_weight
				end
				if amount < const.WellFilledDock and (not closest_empty_dock or closest_empty_dock_distance > path_weight) then
					closest_empty_dock = dock
					closest_empty_dock_distance = path_weight
				end
			end
		end
	end
	return closest_empty_dock or closest_dock
end

function DarthFindBuildingToStore(original_city, garage_or_road, resource,NoWtoW)
	local best_store_bld, min_weight, min_weight_teamster_city = nil, max_int, max_int
	local storage_buildings = objlist:new()
	for i = 1, #g_Cities do
		local city = g_Cities[i]
		if city:HaveDiplomacyActionWith(original_city, "Share Teamsters") and city:HaveDiplomacyActionWith(original_city, "Share All Resources") then
			storage_buildings = storage_buildings:Union(city.labels.Storage:GetObjects())
		end
	end
	for i = 1, #storage_buildings do
		local bld = storage_buildings[i]
		local isDarthWarehouse = bld:FindFirstComponent("DarthStorage") and true or false
		if not (NoWtoW and isDarthWarehouse) then
			if bld:GetEffectiveness("ignore power") > 0 then
				local res = DarthIsBuildingFoodDistributor(bld) and FoodResources[resource] and "Food" or resource
				local res_t = bld.storage:GetResourceInfo(res)
				if res_t and res_t.input then
					local fullness = res_t.amount + res_t.ingoing
					local path_length = DarthGetDistToBuilding(garage_or_road, bld)
					if fullness < res_t.capacity and path_length then
						local amount = res_t.amount - res_t.ingoing
						local weight = (10000 - (5 - bld.BudgetLevel) * 400) * (const.TeamsterOfficeStoreAmountModifier * amount / res_t.capacity - const.TeamsterOfficeStoreDistanceModifier * path_length)
						if isDarthWarehouse then 
							weight = max_int - const.TeamsterOfficeStoreDistanceModifier * path_length
						end
						if bld.city == original_city then
							if min_weight_teamster_city > weight then
								best_store_bld, min_weight_teamster_city = bld, weight
								min_weight = max_int
							end
						elseif weight < min_weight then
							best_store_bld, min_weight = bld, weight
						end
					end
				end
			end
		end
	end
	return best_store_bld
end

function DarthFindBuildingToLoad(teamsters_office, max_capacity)
	local source = teamsters_office.garage
	if not source then
		return
	end
	local max_weight = -1
	local max_weight_teamster_city = -1
	local best_load_bld, best_res, best_store_bld, best_amount
	local storage_buildings = objlist:new()
	for i = 1, #g_Cities do
		local city = g_Cities[i]
		if city:HaveDiplomacyActionWith(teamsters_office.city, "Share Teamsters") then
			storage_buildings = storage_buildings:Union(city.labels.Storage:GetObjects())
		end
	end
	for i = 1, #storage_buildings do
		local bld = storage_buildings[i]
		local isDarthWarehouse = bld:FindFirstComponent("DarthStorage") and true or false
		local path_length = DarthGetDistToBuilding(source, bld)
		if path_length then
			local dist
			for i = 1, #Resources do
				local res_t = bld.storage:GetResourceInfo(Resources[i])
				if res_t and res_t.output then
					local amount = res_t.amount - res_t.outgoing
					if amount > 0 then
						dist = dist or 5 + path_length / guim
						local capacity = res_t.capacity
						if bld.dock then
							capacity = 2 * bld.city:GetTradeImportCapacity()
						end
						local weight = (10000 - (5 - bld.BudgetLevel) * 400) * (const.TeamsterOfficeLoadAmountModifier * amount / capacity - const.TeamsterOfficeLoadDistanceModifier * dist)
						if bld.city == teamsters_office.city then
							if max_weight_teamster_city < weight then
								local building_to_store = DarthFindBuildingToStore(bld.city, bld.garage, Resources[i],isDarthWarehouse)
								if not building_to_store and not bld.dock then
									if isDarthWarehouse then
										if res_t.input == false then
											building_to_store = DarthFindClosestDock(bld.city, bld.garage, Resources[i])
										end
									else
										building_to_store = DarthFindClosestDock(bld.city, bld.garage, Resources[i])
									end
								end
								if building_to_store then
									best_load_bld, max_weight_teamster_city, best_res, best_store_bld, best_amount = bld, weight, Resources[i], building_to_store, Min(amount, max_capacity)
									max_weight = max_int
								end
							end
						elseif weight > max_weight then
							local building_to_store = DarthFindBuildingToStore(bld.city, bld.garage, Resources[i])
							if not building_to_store and not bld.dock then
								if isDarthWarehouse then
									if res_t.input == false then
										building_to_store = DarthFindClosestDock(bld.city, bld.garage, Resources[i])
									end
								else
									building_to_store = DarthFindClosestDock(bld.city, bld.garage, Resources[i])
								end
							end
							if building_to_store then
								best_load_bld, max_weight, best_res, best_store_bld, best_amount = bld, weight, Resources[i], building_to_store, Min(amount, max_capacity)
							end
						end
					end
				end
			end
		end
	end
	return best_load_bld, best_store_bld, best_res, best_amount
end



